/*!
 * windows: jQuery plugin for full-screen scrolling windows.
 * Version: 0.5
 * Original author: David Norminton
 * Website: http://davenorm.me
 */
(function($){

   var screen_height = $(window).height(),
       screen_width  = $(document).width;
    

   function method( element ) {
       
       setDimensions( element );
    
       $(window).scroll( function(){

           var elementOffSet = element.offset().top,
               elementHeight = element.height(),
               elementOffBottom = elementOffSet + element.height(),
               scroll = $(window).scrollTop(),
               elementOnTop = elementOffSet + ( elementHeight ),
               elementOutRange = elementOffSet - ( elementHeight / 2 );
       
           // check if element is in range
           // give better description for this
           if ( elementOffSet < scroll + 1  &&  elementOnTop > scroll + 1  ) {

               console.log( elementOffSet, '  ', elementOnTop , '  ', scroll );
               
               // detect user has stopped scrolling
               // http://stackoverflow.com/questions/9144560/jquery-scroll-detect-when-user-stops-scrolling
               clearTimeout($.data(this, 'scrollTimer'));

               $.data(this, 'scrollTimer', setTimeout(function() {
                            //  console.log( 'moving up ', elementOffSet, '  ', elementOnTop , '  ', scroll );
                          // move element to top of screen 
                          // http://stackoverflow.com/questions/12772648/jquery-animate-to-scroll-to-top-of-div
                          // calculate which way to slide
                          var elTop = elementOffSet + ( elementHeight / 2 ); 
                          if ( scroll > elTop ) {
                              $('html, body').animate({ scrollTop: elementOffSet + elementHeight });
                          } else {
                              $('html, body').animate({ scrollTop: elementOffSet });
                          }
                      }, 500)); 
              }

       });
   }


   // add a min-height and min-width based on document properties to element
   function setDimensions( element ) {

      return element.css({'min-height': screen_height, 'min-width': screen_width});

   }
  

   $.fn.myplugin = function() {

       // loop over each element and set dimensions

       this.each(function(){  method($(this)); });
   };

// pass in jQuery objects to be used in plugin
}( jQuery));
